#include<reg51.h>
#include<intrins.h>
#include<string.h>
////////////////////////////////////////
unsigned char username[]="Username:";
unsigned char loginreq[]="login";
unsigned char error[]="Error";
unsigned char memretrieve[]="mem";
unsigned char loginprompt[]="$:";
unsigned char inputstring[10];
///////////////////////////////////////
void delay(unsigned int count)
{	int i,j;
	for(i=0;i<count;i++)
	 	for(j=0;j<1275;j++);
}
///////////////////////////////////////
sbit sda=P2^6;
sbit scl=P2^7;
sbit led1=P2^5;
bit ack;
unsigned char current_mem_add=0x00;
unsigned char input_data[9];
unsigned char eprom_data[9];
unsigned char read;
///////////////////////////////////////


void start()
{
	sda=1;
	scl=1;
	_nop_();
	_nop_();
	sda=0;
	scl=0;
}

void stop()
{
	sda=0;
	scl=1;
	_nop_();
	_nop_();
	sda=1;
	scl=0;
}

void acknowledge()
{
	scl=1;
	_nop_();
	_nop_();
	scl=0;
}

void send_data_eprom(unsigned char data1)
{
	unsigned int k;
	unsigned char data2;
	data2=data1;
	for(k=0;k<8;k++)
	{
		sda=data2/128;
		data2=data2<<1;
		scl=1;
		_nop_();
		_nop_();
		scl=0;
	}
	ack=sda;
	sda=0;
}

unsigned char read_byte(void)
{
	unsigned int l;
	sda=1;
	read=0;

	
	for(l=0;l<8;l++)
	{
		read=read<<1;
		scl=1;
		_nop_();
		_nop_();
		if(sda==1)
			read++;
		scl=0;
	}
	sda=0;
	return read;
}

void savedata()
{

		unsigned int m;
		start();
		send_data_eprom(0xA0);
		acknowledge();
		send_data_eprom(0x00);
		acknowledge();
			 for(m=0;m<8;m++)
			 	{
				send_data_eprom(inputstring[m]); //hyper terminal data
				acknowledge();
				if(inputstring[m]=='\0')
					{
						break;
					}
				}
		stop();
		//current_mem_add++;
		
		if(ack==0)
		{
			led1=0;
			delay(20);
			led1=1;
		}
		else
		{
			led1=1;
		}
	acknowledge();

}	

//current_mem_add=0x00;
	
/*	start();
	send_data_eprom(0xA0);
	acknowledge();
	send_data_eprom(0x00);
	acknowledge();
	send_data_eprom(current_mem_add);
	acknowledge();
	stop();	    */
	



	/////////////////////////////////////////////////

/* unsigned char read_current_mem_add(void)
{
	start();
	send_data_eprom(0xA0);
	acknowledge();
	send_data_eprom(0x00);
	acknowledge();
	start();
	send_data_eprom(0xA1);
	acknowledge();
	current_mem_add = read_byte();
	acknowledge();
	stop();
}  */

void read_eprom_data(void)
{
	
	unsigned int n=0;
	//eprom_data[n]='A';

	start();
	send_data_eprom(0xA0);
	acknowledge();
	send_data_eprom(0x00);
	acknowledge();
	start();
	send_data_eprom(0xA1);
	acknowledge();
	do
		{
			eprom_data[n]= read_byte();
			acknowledge();
			n++;
		}while(n!=8);
	stop();
	eprom_data[n-1]='\0';


}
////////////////////////////////////////////

///////////////////////////////////////////
///////////////////////////////////////////
void serialinit(void)
{
TMOD= 0x20;
TH1= 0xFD;
SCON=0x50;
TR1=1;
}
///////////////////////////////////////////
void getdata(void)
{
	unsigned int o;
    o=0;
	inputstring[0]='\0';
	while(inputstring[o-1]!=0x0D)
	{
		while(RI==0);
		inputstring[o]=SBUF;
		o++	;
		RI=0;
	}
	inputstring[o-1]='\0';
	o=0;
}
//////////////////////////////////////////
void senddata(unsigned char dat[])
{
	unsigned int p;
	p=0;
	while(dat[p])
	{
		SBUF=dat[p];
		while(TI==0);
		TI=0;
		p++;
	}
	p=0;
}
//////////////////////////////////////////
void nextline(void)
{

		SBUF=0x0A;
		while(TI==0);
		TI=0;

		SBUF=0x0D;
		while(TI==0);
		TI=0;
	
	
}
/////////////////////////////////////////

void main()
{
	unsigned int q=0;
	serialinit();
	
start:

	while(loginprompt[q])
	{
		SBUF=loginprompt[q];
		while(TI==0);
		TI=0;
		q++;
	}
	q=0;

	getdata();
	nextline();

	if(strcmp(inputstring,loginreq)==0)
		{
			senddata(username);
			
			getdata();
			//strcpy(input_data,inputstring);
			nextline();
			senddata(inputstring);
			nextline();
			savedata();
			nextline();
			goto start;
		
		}

	else if(strcmp(inputstring,memretrieve)==0)
		{
			read_eprom_data();
			nextline();
			senddata(eprom_data);
			nextline();
			goto start;
				
		}
	else
		{
			senddata(error);
			nextline();
			goto start;
		}



}











































